searchNodes=[{"doc":"Use inline SVGs in Phoenix","ref":"PhoenixSVG.html","title":"PhoenixSVG","type":"module"},{"doc":"List all of the SVG files in the given directory. Returns a list of all the files, and an MD5 hash of the list so it can be determined if the list changed and needs to be re-compiled.","ref":"PhoenixSVG.html#list_files/1","title":"PhoenixSVG.list_files/1","type":"function"},{"doc":"Reads a file and parses out the name and path. The name will be the filename without the extension, and the path will be a list of directory names the file is nested in relative to the base path.","ref":"PhoenixSVG.html#read_file!/2","title":"PhoenixSVG.read_file!/2","type":"function"},{"doc":"Renders an inline svg from a cached file. Attributes :name - The name of the svg file, excluding the .svg extension. :path - A list of nested paths if the file is not in the root. Any other attributes will be passed through to the &lt;svg&gt; tag. Note that this function should never be called directly with PhoenixSVG.svg . It's meant to be called from the svg function generated in the __using__ macro. See the Getting Started guide.","ref":"PhoenixSVG.html#svg/1","title":"PhoenixSVG.svg/1","type":"function"},{"doc":"Converts a map or keyword list into HTML-safe attributes. Any keys that contain an underscore will be converted to a dash in the HTMl attribute. For example, %{foo_bar: &quot;foo_bar&quot;} will result in the attribute foo-bar=&quot;foo_bar&quot; .","ref":"PhoenixSVG.html#to_safe_html_attrs/1","title":"PhoenixSVG.to_safe_html_attrs/1","type":"function"},{"doc":"Use inline SVGs in your Phoenix application for defining custom icon libraries. This module will load the files during compilation so you don't have to worry about performance, handle refreshing the cache when the files change, inline the SVG tags into your templates, and includes support for defining custom attributes with defaults in the config.","ref":"readme.html","title":"README","type":"extras"},{"doc":"def deps do [ { :phoenix_svg , &quot;~&gt; 1.0&quot; } ] end The recommended way to install into your Phoenix application is to create a file at lib/myapp_web/svg.ex (replacing myapp with the name of your app): defmodule MyAppWeb.SVG do use PhoenixSVG , otp_app : :myapp end This is so the files are only read and cached once. Then you can simply import MyAppWeb.SVG wherever you need to use the component. A good place to do this is in the html_helpers function in lib/myapp_web.ex : defp html_helpers do quote do # ... import MyAppWeb.SVG # ... end end Now when you start your Phoenix server, all the SVG files located in priv/svgs will be loaded into memory and can be used with the svg component. For example, if you have a file at priv/svgs/checkmark.svg : &lt; .svg name = &quot;checkmark&quot; /&gt; An error will be raised if the file is not found. If your svgs are nested in a subdirectory, specify a list in the path attribute with one item representing each folder. e.g. for priv/svgs/branding/circle/checkmark.svg : &lt; .svg name = &quot;checkmark&quot; path = { [ &quot;branding&quot; , &quot;circle&quot; ] } /&gt; Any attributes defined will be passed through to the &lt;svg&gt; tag: &lt; .svg name = &quot;checkmark&quot; class = &quot;foobar&quot; /&gt;","ref":"readme.html#getting-started","title":"README - Getting Started","type":"extras"},{"doc":":otp_app - The name of your OTP application. This is required. :as - The name of the generated component function. Defaults to :svg . :from - The path of your svg files relative to your project directory. If using releases, make sure this path is included in your release directory ( priv is included by default). Defaults to priv/svgs . :attributes - A map of default attributes to inject into the SVG tags. Defaults to %{} . Example use PhoenixSVG , otp_app : :myapp , as : :icon , from : &quot;priv/static/icons&quot; , attributes : %{ width : &quot;24px&quot; , height : &quot;24px&quot; } &lt; .icon name = &quot;checkmark&quot; /&gt;","ref":"readme.html#options","title":"README - Options","type":"extras"},{"doc":"If you add, remove, or change svg files while the server is running, they will automatically be replaced in the cache and you don't have to restart for them to take effect. If you want to live reload the page when a file changes, add ~r&quot;priv/svgs/.*(svg)$&quot; to the patterns list of the Endpoint config in config/dev.exs .","ref":"readme.html#local-development","title":"README - Local Development","type":"extras"}]